#include <EasyTransfer.h>
// --------------------------------------------------------------------
// ET: create object
EasyTransfer ET;

// ET:
struct SEND_DATA_STRUCTURE {
//put the variable definitions here for the data you want to send
//THIS MUST BE EXACTLY THE SAME ON THE OTHER ARDUINO
  int a_value;			// variable to store the data to transfer per Serial(TX) to the 2nd. Arduino
};

SEND_DATA_STRUCTURE mydata;	// give a name to the group of data

// --------------------------------------------------------------------
// Global Variables
int ledPin = 9;		// variable-name for the PWM-Output-Pin (D9) to the Arduino-LED on D13(=Input)
int analogPin = 0;	// variable-name for the Poti-Input-Pin(=A0) for the AD-Converter to read the analog-value
byte counter = 0;	// simple counter-variable

// --------------------------------------------------------------------
// Arduino-Setup (one pass at Start-Time)
void setup() {
  pinMode(ledPin, OUTPUT);	// PWM-Output (D9) for the Arduino-LED (D13)
  pinMode(13, INPUT);		// PWM-Input to D13, Arduino-LED in tristate-mode (=high-impedance state)
  pinMode(3, INPUT_PULLUP);	// D3: Input-Signal from On-Switch, switched per Diode to GND (=LOW, to activate the operating voltage through D4)
  pinMode(4, OUTPUT);		// D4: Output to the hold-transistor T1 (Small-Signal-Mosfet BS170) to hold the operating-voltage for 1.6 Seconds
  digitalWrite(4, HIGH);		// start and hold the operating-voltage, T1 must be active, switching the gate of T2 to GND.

  Serial.begin(4800);		// Sets the data rate in bits per second (baud) for serial data transmission
  // ET: start the library, pass in the data details and the name of the serial port. Can be Serial, Serial1, Serial2, etc.
  ET.begin(details(mydata), &Serial);
}
// --------------------------------------------------------------------
// Main loop
void loop() {
//this is how to access the variables. [name of the group].[variable name]
  mydata.a_value = analogRead(analogPin);	// "a_value" is in the range of 0-1023(!), this variable is declared above (s.th.)
//send the data
  if (counter < 25) {		// in the time the counter counts up to value 25 (=20ms delay per loop *25 loops = 0.5 Seconds time)...
     ET.sendData();		// send the data per Serial (=through TX, the default Serial-Output from the Atmega328)...
     }				// before the operating-voltage collapses (after ~80 loops)

//Just for fun, write "mydata.a_value/4" out too (max.-value for analogWrite is 255, therefore divided the a_value/4)
analogWrite(ledPin,mydata.a_value/4);		// to the "ledPin" D9 (=PWM-Output) => passed to Pin D13, the In/Output from the Arduino-LED
/*
digitalWrite(ledPin, HIGH);
delayMicroseconds(500);
digitalWrite(ledPin, LOW);
*/
counter += 1;			// increment the counter" +1"
if (counter == 7) {		// and count 10 loops to hold the operating-voltage 2 Seconds, then OFF-it to save battery:
   digitalWrite (4, LOW);	// put D4-Output LOW, so Mosfet T1 goes HIGH (=Gate-T2) and Mosfet T2 blocks the operating-voltage (=Off!)
   }
if ((digitalRead(3) == LOW)) {	// in the time the On-Switch on D3 is hold LOW (to adjust the dimmer with the Poti), hold the counter (on state zero)...
    counter = 0;
   }
delay(80);			// a small 20ms-delay per loop
}
// --------------------------------eof---------------------------------
